#!/usr/bin/env python
##
#
# Author: Ivanov Pter
# E-Mail: cyclops@szerepjatek.cjb.net
# Homepage: http://szerepjatek.cjb.net
# Program: Nvgenertor
# Version: 0.1.2
# License: Freeware (read nevgen.html)
#
##
####################################
# Copyright (C) Ivanov Pter, 2000 #
####################################
#
# TO DO:
# . lang (hun/eng)
# + nevek szama
# . masik fajta ELE (NOUN/ADJ/NADJ) [in progress...]
# ADJECTIVE mellknv
# NOUN fnv


from Tkinter import *
from tkMessageBox import *
from FileDialog import *
from string import *
from random import *
import sys
import os
import pickle

progname = "Nvgenertor 0.1.2"
cmds = {"#PRE": 0, "#MID": 1, "#SUF": 2,    #ele_type 0
	"#NOUN": 0, "#ADJ": 1, "#NADJ": 2,  #ele_type 1
	"#END": -2}
ele_type = 0 #default
#names = [[], [], [], [], []] #ez nem is kell -> process ()
#Nyomkvets
#0: ki van kapcsolva
#definilt szintek: 4, 5
debuglevel = 1

if sys.platform == "win32":
	path = sys.argv[0][:rfind (sys.argv[0], "\\")+1]
	configfile = path + "nevgen.cfg"
	graph_button = FALSE
	pad_x = 5
	pad_y = 5
else:
	path = sys.argv[0][:rfind (sys.argv[0], "/")+1]
	configfile = os.environ['HOME'] + "/.nevgen"
	graph_button = TRUE
	pad_x = 0
	pad_y = 0

if debuglevel >= 4:
	print "path: [" + path + "]"
	print "configfile: [" + configfile + "]"

class Opt:
	newname_move = TRUE
	quit_save = TRUE
	name_num = 10
	if sys.platform == "win32":
	    filename2 = path + "nevek.txt"
	else:
	    filename2 = os.environ['HOME'] + "/nevek.txt"
	overwrite = FALSE
	quit_save_names = FALSE
	if sys.platform == "win32":
		filename = path + "fantasy\\name-1.ele"	#opt
	else:
		filename = path + "fantasy/name-1.ele"	#opt
	
opt = Opt ()

wins = {} #nem is biztos hogy kell...

def gen_name ():
	if ele_type == 0:#len (names[0])>0:
		# type "PRE/MID/SUF"
		if len (names[1]) > 0:
			name = names [0][randint (0, len (names[0]))-1] + \
				  names [1][randint (0, len (names[1]))-1] + \
				  names [2][randint (0, len (names[2]))-1]
		else:
			name = names [0][randint (0, len (names[0]))-1] +\
				  names [2][randint (0, len (names[2]))-1]
	else:
		# type NOUN/ADJ/NADJ ***INCOMPLETE***
		if len (names[2]) > 0:
			a = randint (0, 4)
			if a == 0:
				name = names [1][randint (0, len (names[1]))-1] + " " +\
				       names [2][randint (0, len (names[2]))-1] + " " +\
				       names [0][randint (0, len (names[0]))-1]
			elif a == 1:
				name = names [1][randint (0, len (names[1]))-1] + " " +\
				       names [0][randint (0, len (names[0]))-1]          
			elif a == 2:
				name = names [0][randint (0, len (names[0]))-1] + " of " +\
				       names [1][randint (0, len (names[1]))-1]
			elif a == 3:
				name = names [1][randint (0, len (names[1]))-1] + " " +\
				       names [2][randint (0, len (names[2]))-1]           
			elif a == 4:
				name = names [2][randint (0, len (names[1]))-1] + " " +\
				       names [0][randint (0, len (names[2]))-1]           
			if debuglevel >= 1:
				name = str (a + 1) + " " + name #debug
		else:
			name = names [1][randint (0, len (names[1]))-1] + " " +\
			       names [0][randint (0, len (names[0]))-1]
			if debuglevel >= 1:
				name = "0 " + name
	name = capwords (name)
	return name

def newname (event=None): #event a "bind" fuggveny miatt kell
	if opt.newname_move:
		add_name ()
	listbox.delete (0, END)
	for i in range (opt.name_num):
		listbox.insert (END, gen_name ())
		listbox.pack (side=LEFT, fill=BOTH)

def process (filename):
	global names, ele_type
	if debuglevel >= 4:
		print "Processing " + filename + "..."
	names = [[], [], [], [], []]
	try:
		f = open (filename, "r")
	except IOError:
		showerror (title="Hiba", message=filename + " nev file-t nem tudom olvasni.")
	else:
		#showinfo (title="Informci", message="File betltve.")
		buf = f.readlines ()
		f.close ()
		valid = FALSE
		state = -1
		for i in buf:
			cmd = FALSE
			for j in cmds.keys ():
				if find (i, j) != -1:
					state = cmds[j]
					cmd = TRUE
					if debuglevel >= 5:
						print "Found: ", j, "Num: ", state
					if j in ["#PRE", "#MID", "#SUF"]:
						ele_type = 0
					elif j in ["#NOUN", "#ADJ", "#NADJ"]:
						ele_type = 1
			if state == -2:
				valid = TRUE
				break
			if i[0] == "#":
				continue
			if state >= 0 and cmd == FALSE:
				names[state].append (rstrip (i))
				
		if valid:
			for i in range (len (names[0])):
				names[0][i] = capitalize (names[0][i])
			newname ()
		else:
			showerror (title="Hiba", message="rvnytelen file")

		if len (names[0]) == 0 or len (names[2]) == 0:
			showerror (title="Hiba", message="rvnytelen file")

		if sys.platform == "win32":
			label.config (text="Forrs: "+filename[rfind (filename, "\\")+1:])
		else:
			label.config (text="Forrs: "+filename[rfind (filename, "/")+1:])
		
		if debuglevel >= 4:
			print filename[rfind (filename, "/")+1:],
			if valid:
				print "Ok"
			else:
				print "Invalid!"
			print "pre/noun:", len (names[0]), "  mid/adj:", len (names[1]), "  suf/adj:", len (names[2])
			print "ele_type:", ele_type
	
def fileopen ():
	global opt
	fd = LoadFileDialog (root)
	filename_ = fd.go (pattern="*.ele")
	if filename_:
		opt.filename = filename_
		process (opt.filename)

def options_del (event=None):
	if wins.has_key ("options"):
		del wins["options"]
		optwin.destroy ()

def options_ok (event=None):
	if wins.has_key ("options"):
		if debuglevel >= 5:
			print quit_save_names_.get ()
		opt.newname_move = newname_move_.get ()
		opt.quit_save = quit_save_.get ()
		opt.quit_save_names = quit_save_names_.get ()
		opt.name_num = atoi (name_num_.get ())
		if opt.name_num > 1000:
			opt.name_num = 1000
		opt.filename2 = filename2_.get ()
		opt.overwrite = overwrite_.get ()
		#nem szabad a funkcio elejere tenni, azert... probald ki es meglatod
		del wins["options"]
		optwin.destroy ()

def options_save (event=None):
	if debuglevel >= 4:
		print "Saving options..."
	try:
		f = open (configfile, "w")
	except IOError:
		showerror (title="Hiba", message=configfile+" nev file-t nem tudom rni.")
	else:
		#opt oszalyt f file-ba menti
		pickle.dump (opt, f)
		f.close ()

def options ():
	if not wins.has_key ("options"):
		global optwin, newname_move_, quit_save_, name_num_, quit_save_names_, filename2_, overwrite_
		optwin = Toplevel ()
		optwin.resizable (FALSE, FALSE) # X, Y iranyban
		wins["options"] = optwin
		optwin.title ("Belltsok")
		optwin.protocol("WM_DELETE_WINDOW", options_del)
		f = Frame (optwin)
		f.pack (fill=X)
		Label (f, text="Generlt nevek szma: ").pack (side=LEFT)
		name_num_ = Entry (f, width=4)
		name_num_.insert (INSERT, opt.name_num)
		name_num_.pack (side=LEFT)

		f = Frame (optwin)
		f.pack (fill=X)
		l = Label (f, text="Filenv a generlt nevek szmra: ")
		l.pack (fill=X, side=LEFT)
		filename2_ = Entry (optwin, width=20)
		filename2_.insert (INSERT, opt.filename2)
		filename2_.pack (fill=X, side=TOP)

		f = Frame (optwin)
		f.pack (fill=X)

		newname_move_ = BooleanVar ()
		quit_save_ = BooleanVar ()
		quit_save_names_ = BooleanVar ()
		overwrite_ = BooleanVar ()

		c = Checkbutton(f, text="j nv generlsakor kijellteket thelyezi", 
			variable=newname_move_, justify=LEFT, anchor=W)
		c.pack (fill=X)
		if opt.newname_move:
			c.select ()

		c2 = Checkbutton(f, text="Kilpskor belltsok mentse", 
			variable=quit_save_, justify=LEFT, anchor=W)
		c2.pack (fill=X)
		if opt.quit_save:
			c2.select ()

		c3 = Checkbutton(f, text="Kilpskor kivlasztott nevek mentse", 
			variable=quit_save_names_, justify=LEFT, anchor=W)
		c3.pack (fill=X)
		if opt.quit_save_names:
			c3.select ()

		c4 = Checkbutton(f, text="Nevek fellrsa elmentskor", 
			variable=overwrite_, justify=LEFT, anchor=W)
		c4.pack (fill=X)
		if opt.overwrite:
			c4.select ()

		f = Frame (optwin)
		f.pack (fill=BOTH)
		Button (f, text="Ok", command=options_ok, default=ACTIVE).pack (side=LEFT, fill=X,
										padx=pad_x, pady=pad_y)
		Button (f, text="Mgsem", command=options_del).pack (side=LEFT, fill=X,
								     padx=pad_x, pady=pad_y)
		Button (f, text="Ment", command=options_save).pack (side=LEFT, fill=X,
								    padx=pad_x, pady=pad_y)
		#csak az options ablak az aktiv, ha nincs beallitva a fo ablakban
		#mukodik a tobbi gomb es ablakelem
		optwin.grab_set () 
		
		optwin.bind ("<Return>", options_ok)
		optwin.bind ("<Escape>", options_del)
		
def add_all_name ():
	for i in range (listbox.size ()):
		listbox2.insert (END, listbox.get (i))
		listbox2.pack (side=LEFT, fill=BOTH)
	listbox.delete (0, END)

def add_name ():
	for i in listbox.curselection ():
		listbox2.insert (END, listbox.get (i))
		listbox2.pack (side=LEFT, fill=BOTH)
	s = listbox.curselection ()
	#szamsorozatbol listat kell kesziteni
	s2 = []
	for i in range (len (s)):
		s2.append (s [i])
	#visszafele torlunk!
	s2.reverse ()
	for i in s2:
		listbox.delete (i)
	
def delete_all_name ():
	for i in range (listbox2.size ()):
		listbox.insert (END, listbox2.get (i))
		listbox.pack (side=LEFT, fill=BOTH)
	listbox2.delete (0, END)
	
def delete_name ():
	for i in listbox2.curselection ():
		listbox.insert (END, listbox2.get (i))
		listbox.pack (side=LEFT, fill=BOTH)
	s = listbox2.curselection ()
	#szamsorozatbol listat kell kesziteni
	s2 = []
	for i in range (len (s)):
		s2.append (s [i])
	#visszafele torlunk!
	s2.reverse ()
	for i in s2:
		listbox2.delete (i)

def about ():
	showinfo (title="Nvjegy", message=progname+"\n\n"
		  "Copyright (C) Ivanov Pter, 2000\n"
		  "E-Mail: cyclops@szerepjatek.cjb.net")

def save_names ():
	if listbox2.size ()==0:
		return
	if debuglevel >= 4:
		print "Saving names..."
	try:
		if opt.overwrite:
			f = open (opt.filename2, "w")
		else:
			f = open (opt.filename2, "a")
	except IOError:
		showerror (title="Hiba", message=opt.filename2+" nev file-t nem tudom rni")
	else:
		if not opt.overwrite:
			f.write ("---------------\n")
		for i in range (listbox2.size ()):
			f.write (listbox2.get (i)+"\n")
		f.close ()


def quit (event=None): #event a "bind" fuggveny miatt kell
	if opt.quit_save:
		options_save ()
	root.destroy ()

########
# Main #
########
root = Tk ()
root.title (progname)

bigframe = Frame ()
bigframe.pack (side=TOP, fill=BOTH, expand=1)

frame = Frame (bigframe)
frame.pack (side=LEFT, fill=BOTH, expand=1)

f = Frame (frame)
l = Label (f, text="Generlt nevek:")
l.pack (side=LEFT)
f.pack (side=TOP, fill=BOTH)

scrollbar = Scrollbar(frame, orient=VERTICAL)
listbox = Listbox(frame, yscrollcommand=scrollbar.set, selectmode=MULTIPLE)
scrollbar.config(command=listbox.yview)
scrollbar.pack(side=RIGHT, fill=Y)
listbox.pack(side=LEFT, fill=BOTH, expand=1)
listbox.select_set (0)

frame3 = Frame (bigframe)
frame3.pack (side=LEFT)

if graph_button == FALSE:
	Button (frame3, text="->", width=2, height=1, command=add_name).pack (side=TOP, fill=BOTH, padx=pad_x, pady=pad_y)
	Button (frame3, text="<-", width=2, height=1, command=delete_name).pack (side=TOP, fill=BOTH, padx=pad_x, pady=pad_y)
	Button (frame3, text=">>", width=2, height=1, command=add_all_name).pack (side=TOP, fill=BOTH, padx=pad_x, pady=pad_y)
	Button (frame3, text="<<", width=2, height=1, command=delete_all_name).pack (side=TOP, fill=BOTH, padx=pad_x, pady=pad_y)
else:
	Button (frame3, bitmap="@" + path + "arrow_right.xbm", width=40, height=20, command=add_name).pack (side=TOP, fill=BOTH, padx=pad_x, pady=pad_y)
	Button (frame3, bitmap="@" + path + "arrow_left.xbm", width=40, height=20, command=delete_name).pack (side=TOP, fill=BOTH, padx=pad_x, pady=pad_y)
	Button (frame3, bitmap="@" + path + "brelgg.xbm", width=40, height=20, command=add_all_name).pack (side=TOP, fill=BOTH, padx=pad_x, pady=pad_y)
	Button (frame3, bitmap="@" + path + "brelll.xbm", width=40, height=20, command=delete_all_name).pack (side=TOP, fill=BOTH, padx=pad_x, pady=pad_y)

frame2 = Frame (bigframe)
frame2.pack (side=RIGHT, fill=BOTH, expand=1)

f2 = Frame (frame2)
l = Label (f2, text="Kivlasztott nevek:")
l.pack (side=LEFT)
f2.pack (side=TOP, fill=BOTH)

scrollbar2 = Scrollbar(frame2, orient=VERTICAL)
listbox2 = Listbox(frame2, yscrollcommand=scrollbar2.set, selectmode=MULTIPLE)
scrollbar2.config(command=listbox2.yview)
scrollbar2.pack(side=RIGHT, fill=Y)
listbox2.pack(side=LEFT, fill=BOTH, expand=1)
listbox2.select_set (0)

frame = Frame (root)
if sys.platform == "win32":
	label = Label (frame, text="Forrs: " + opt.filename[rfind (opt.filename, "\\")+1:], justify=LEFT)
else:
	label = Label (frame, text="Forrs: " + opt.filename[rfind (opt.filename, "/")+1:], justify=LEFT)
label.pack (side=LEFT, fill=X)
frame.pack (fill=X)

frame = Frame (root)
Button (frame, text="j nevek", command=newname, default=ACTIVE).pack (side=LEFT, fill=X, padx=pad_x, pady=pad_y)
Button (frame, text="Megnyit", command=fileopen).pack (side=LEFT, fill=X, padx=pad_x, pady=pad_y)
Button (frame, text="Belltsok", command=options).pack (side=LEFT, fill=X, padx=pad_x, pady=pad_y)
Button (frame, text="Ment", command=save_names).pack (side=LEFT, fill=X, padx=pad_x, pady=pad_y)
Button (frame, text="Nvjegy", command=about).pack (side=LEFT, fill=X, padx=pad_x, pady=pad_y)
Button (frame, text="Kilp", command=quit).pack (side=LEFT, fill=X, padx=pad_x, pady=pad_y)
frame.pack (side=BOTTOM, fill=BOTH)

#root.geometry ("%dx%d%+d%+d" % (450, 250, 0, 0))
root.resizable (0, 0)
root.protocol("WM_DELETE_WINDOW", quit)

root.bind ("<Return>", newname)
root.bind ("<Escape>", quit)

if debuglevel >= 4:
	print "Loading options...",
try:
	f = open (configfile)
except IOError:
	if debuglevel >= 4:
		print "Error"
else:
	opt = pickle.load (f)
	f.close ()
	if debuglevel >= 4:
		print "Ok"
process (opt.filename)

if debuglevel >= 4:
	print "A program a kvetkez helyrl lett indtva: [" + path + "]\nargv[0]: [" + sys.argv[0] + "]"
#root.mainloop ()
mainloop ()

# Copyright (C) Ivanov Pter, 2000
# End of file
